package SM.diglib;

import org.ginf.*;
import org.ginf.helpers.*;
import org.w3c.rdf.*;
import org.xml.sax.*;
import java.io.*;

/**
 * This class provides handy access to schema information.
 * THIS FILE HAS BEEN GENERATED AUTOMATICALLY.
 */

public class SDLIP implements SchemaLoader {

  /** Namespace URI of this schema */
  public static final String NS = "http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-dl-search";

  /** This property points to a query String contained in a search request. */
  public static final Resource queryString = new Resource(NS + "#queryString");

  /** Error during the search */
  public static final Resource Error = new Resource(NS + "#Error");

  /** Search properties like query, limit etc. act as search constraints.
		If a library server does not support some specific search constrain,
		it is supposed to issue a warning message showing that the results delivered
		are a superset of what the client might expect. */
  public static final Resource searchConstraint = new Resource(NS + "#searchConstraint");

  /** Items delivered in the result set are instances of this class.
		Since a resource may be an instance of more than one class,
		the search service may submit additional typing information, e.g.
		like Document, File, Map etc.
	 */
  public static final Resource ResultItem = new Resource(NS + "#ResultItem");

  /** The maximal number of search results the client is willing to handle.
		Range is an integer (literal), not specified because typing on RDF is
		still under way. */
  public static final Resource limit = new Resource(NS + "#limit");

  /** This property points to a query contained in a search request. */
  public static final Resource query = new Resource(NS + "#query");

  /** The scope of the search request.
		The range is a collection of resources or a single resource.
		No literals are possible as a scope (use resource URI instead). */
  public static final Resource scope = new Resource(NS + "#scope");

  /** Not the complete result has been delivered */
  public static final Resource PartialResult = new Resource(NS + "#PartialResult");

  /** Search result */
  public static final Resource Result = new Resource(NS + "#Result");

  /** Identifies a search request */
  public static final Resource Search = new Resource(NS + "#Search");

  /** In case that the query is queryString this property says what
		query language This property points to a query String contained in a search request. */
  public static final Resource queryLang = new Resource(NS + "#queryLang");

  /** The attributes returned for each digital object found.
		No a searchConstraint since number of results is unaffected by
		this property. */
  public static final Resource attributes = new Resource(NS + "#attributes");

  /** Points to a result item which is a resource having
		further properties requested by the search (property attributes) */
  public static final Resource resultItem = new Resource(NS + "#resultItem");

  /** Gives the size of the complete(!) result set,
		even if returns as a PartialResult.
		Range is an integer (a literal containing an integer) */
  public static final Resource resultSize = new Resource(NS + "#resultSize");

  /** Use this property to rank the search results.
		Rank can also be just a enumeration of the result set.
		It is intended to provide some kind of order.
		If a particular ranking algorithm is used, create a
		subPropertyOf this property. */
  public static final Resource rank = new Resource(NS + "#rank");


  static final String _schemaData = "<?xml version='1.0' encoding='ISO-8859-1'?>"+
	"<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\""+
	"	 xmlns:s=\"http://www.w3.org/TR/WD-rdf-schema#\">"+
	"<s:Class rdf:ID=\"Error\">"+
	"	<s:subClassOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#Error\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"PartialResult\">"+
	"	<s:subClassOf rdf:resource=\"#Result\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"Result\">"+
	"	<s:subClassOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#SuccessfulReply\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"ResultItem\"/>"+
	"<s:Class rdf:ID=\"Search\">"+
	"	<s:subClassOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-coll#ConstrainedCollection\"/>"+
	"	<s:subClassOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#Request\"/>"+
	"</s:Class>"+
	"<rdf:Property rdf:ID=\"attributes\">"+
	"	<s:subPropertyOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-coll#attributes\"/>"+
	"	<s:domain rdf:resource=\"#Search\"/>"+
	"	<s:range rdf:resource=\"http://www.w3.org/TR/WD-rdf-schema#Container\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"limit\">"+
	"	<s:domain rdf:resource=\"#Search\"/>"+
	"	<s:subPropertyOf rdf:resource=\"#searchConstraint\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"query\">"+
	"	<s:domain rdf:resource=\"#Search\"/>"+
	"	<s:subPropertyOf rdf:resource=\"#searchConstraint\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"queryLang\">"+
	"	<s:domain rdf:resource=\"#Search\"/>"+
	"	<s:subPropertyOf rdf:resource=\"#query\"/>"+
	"	<s:range rdf:resource=\"http://www.w3.org/TR/WD-rdf-schema#Literal\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"queryString\">"+
	"	<s:domain rdf:resource=\"#Search\"/>"+
	"	<s:subPropertyOf rdf:resource=\"#query\"/>"+
	"	<s:range rdf:resource=\"http://www.w3.org/TR/WD-rdf-schema#Literal\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"rank\">"+
	"	<s:domain rdf:resource=\"#ResultItem\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"resultItem\">"+
	"	<s:subPropertyOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-coll#item\"/>"+
	"	<s:domain rdf:resource=\"#Result\"/>"+
	"	<s:range rdf:resource=\"#ResultItem\"/>"+
	"	<s:seeAlso rdf:resource=\"#attributes\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"resultSize\">"+
	"	<s:domain rdf:resource=\"#Result\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"scope\">"+
	"	<s:domain rdf:resource=\"#Search\"/>"+
	"	<s:subPropertyOf rdf:resource=\"#searchConstraint\"/>"+
	"	<s:range rdf:resource=\"http://www.w3.org/TR/WD-rdf-schema#Resource\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"searchConstraint\">"+
	"	<s:subPropertyOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-coll#constraint\"/>"+
	"	<s:domain rdf:resource=\"#Search\"/>"+
	"</rdf:Property>"+
	"</rdf:RDF>"+
	"";

  public boolean loadSchema(String uri, RDFFactory factory) {
    if(NS.equals(uri)) {
      InputSource source = new InputSource( new StringReader( _schemaData ) );
      source.setSystemId(NS);
      factory.registry().fetch(source);
      return true;
    } else
      return false;
  }

}
