/**
 * Copyright  Sergey Melnik (Stanford University, Database Group)
 *
 * All Rights Reserved.
 */

package org.ginf;

import org.w3c.rdf.*;

/**
 * SchemaController allows to overload the default
 * behavior in case when new triples added to a model
 * (e.g. by a parser).
 *
 * @author Sergey Melnik <melnik@db.stanford.edu>
 * @see    org.ginf.RDFMS
 * @see    org.ginf.SchemaLoader
 */

public interface SchemaController {
  
  /**
   * Load any schemas if necessary based on the
   * subject, predicate and object used in the triple
   */
  public boolean loadSchema(Triple t, Model m, RDFFactory factory);
  
}
