/**
 * Copyright  Sergey Melnik (Stanford University, Database Group)
 *
 * All Rights Reserved.
 */
package org.ginf;

import org.w3c.rdf.*;

/**
 * Schema loader allows to load schemas from alternative
 * source or schemas that are identified using a URI (which is not URL)
 *
 * @author Sergey Melnik <melnik@db.stanford.edu>
 */

public interface SchemaLoader {

  /**
   * returns true if the loader feels responsible for loading this schema
   * Otherwise SchemaRegistry will ask another loaders.
   * After the call, the schema may have been loaded or just ignored.
   */

  public boolean loadSchema(String uri, RDFFactory factory);
  
}
